From 628e98f52c07bd316cddaeda342f6e0f650bf756 Mon Sep 17 00:00:00 2001
From: sam marshall <s.marshall@open.ac.uk>
Date: Mon, 15 Dec 2014 10:41:47 +0000
Subject: [PATCH 13/15] MDL-42616 filelib: Use config value for custom MIME
 types (1/2)

Uses a new optional config variable to define custom MIME types
in JSON format. Includes new API for accessing and modifying
this data.
---
 config-dist.php              |  17 +
 lib/classes/filetypes.php    | 682 +++++++++++++++++++++++++++++++++++
 lib/filelib.php              | 209 +----------
 lib/phpunit/classes/util.php |   2 +
 lib/tests/filelib_test.php   |  54 +++
 lib/tests/filetypes_test.php | 253 +++++++++++++
 6 files changed, 1016 insertions(+), 201 deletions(-)
 create mode 100644 lib/classes/filetypes.php
 create mode 100644 lib/tests/filetypes_test.php

diff --git a/config-dist.php b/config-dist.php
index 0a8fc37a55f..fd66830894c 100644
--- a/config-dist.php
+++ b/config-dist.php
@@ -508,6 +508,23 @@ $CFG->admin = 'admin';
 // on a shared file system that supports locking.
 //      $CFG->lock_file_root = $CFG->dataroot . '/lock';
 //
+// Moodle 2.9 allows administrators to customise the list of supported file types.
+// To add a new filetype or override the definition of an existing one, set the
+// customfiletypes variable like this:
+//
+// $CFG->customfiletypes = array(
+//     (object)array(
+//         'extension' => 'frog',
+//         'icon' => 'archive',
+//         'type' => 'application/frog',
+//         'customdescription' => 'Amphibian-related file archive'
+//     )
+// );
+//
+// The extension, icon, and type fields are required. The icon field can refer to
+// any icon inside the pix/f folder. You can also set the customdescription field
+// (shown above) and (for advanced use) the groups, string, and defaulticon fields.
+//
 //=========================================================================
 // 7. SETTINGS FOR DEVELOPMENT SERVERS - not intended for production use!!!
 //=========================================================================
